#include "stdafx.h"

#ifndef _MFC_VER

#include "MSU_AFX.h"

// CSize
CSize::CSize()
	{ /* random filled */ }
CSize::CSize(int initCX, int initCY)
	{ cx = initCX; cy = initCY; }
CSize::CSize(SIZE initSize)
	{ *(SIZE*)this = initSize; }
CSize::CSize(POINT initPt)
	{ *(POINT*)this = initPt; }
CSize::CSize(DWORD dwSize)
	{
		cx = (short)LOWORD(dwSize);
		cy = (short)HIWORD(dwSize);
	}
BOOL CSize::operator==(SIZE size) const
	{ return (cx == size.cx && cy == size.cy); }
BOOL CSize::operator!=(SIZE size) const
	{ return (cx != size.cx || cy != size.cy); }
void CSize::operator+=(SIZE size)
	{ cx += size.cx; cy += size.cy; }
void CSize::operator-=(SIZE size)
	{ cx -= size.cx; cy -= size.cy; }
CSize CSize::operator+(SIZE size) const
	{ return CSize(cx + size.cx, cy + size.cy); }
CSize CSize::operator-(SIZE size) const
	{ return CSize(cx - size.cx, cy - size.cy); }
CSize CSize::operator-() const
	{ return CSize(-cx, -cy); }
CPoint CSize::operator+(POINT point) const
	{ return CPoint(cx + point.x, cy + point.y); }
CPoint CSize::operator-(POINT point) const
	{ return CPoint(cx - point.x, cy - point.y); }
CRect CSize::operator+(const RECT* lpRect) const
	{ return CRect(lpRect) + *this; }
CRect CSize::operator-(const RECT* lpRect) const
	{ return CRect(lpRect) - *this; }

// CPoint
CPoint::CPoint()
	{ /* random filled */ }
CPoint::CPoint(int initX, int initY)
	{ x = initX; y = initY; }
#if !defined(_AFX_CORE_IMPL) || !defined(_AFXDLL) || defined(_DEBUG)
CPoint::CPoint(POINT initPt)
	{ *(POINT*)this = initPt; }
#endif
CPoint::CPoint(SIZE initSize)
	{ *(SIZE*)this = initSize; }
CPoint::CPoint(DWORD dwPoint)
	{
		x = (short)LOWORD(dwPoint);
		y = (short)HIWORD(dwPoint);
	}
void CPoint::Offset(int xOffset, int yOffset)
	{ x += xOffset; y += yOffset; }
void CPoint::Offset(POINT point)
	{ x += point.x; y += point.y; }
void CPoint::Offset(SIZE size)
	{ x += size.cx; y += size.cy; }
BOOL CPoint::operator==(POINT point) const
	{ return (x == point.x && y == point.y); }
BOOL CPoint::operator!=(POINT point) const
	{ return (x != point.x || y != point.y); }
void CPoint::operator+=(SIZE size)
	{ x += size.cx; y += size.cy; }
void CPoint::operator-=(SIZE size)
	{ x -= size.cx; y -= size.cy; }
void CPoint::operator+=(POINT point)
	{ x += point.x; y += point.y; }
void CPoint::operator-=(POINT point)
	{ x -= point.x; y -= point.y; }
CPoint CPoint::operator+(SIZE size) const
	{ return CPoint(x + size.cx, y + size.cy); }
CPoint CPoint::operator-(SIZE size) const
	{ return CPoint(x - size.cx, y - size.cy); }
CPoint CPoint::operator-() const
	{ return CPoint(-x, -y); }
CPoint CPoint::operator+(POINT point) const
	{ return CPoint(x + point.x, y + point.y); }
CSize CPoint::operator-(POINT point) const
	{ return CSize(x - point.x, y - point.y); }
CRect CPoint::operator+(const RECT* lpRect) const
	{ return CRect(lpRect) + *this; }
CRect CPoint::operator-(const RECT* lpRect) const
	{ return CRect(lpRect) - *this; }

// CRect
CRect::CRect()
	{ /* random filled */ }
CRect::CRect(int l, int t, int r, int b)
	{ left = l; top = t; right = r; bottom = b; }
CRect::CRect(const RECT& srcRect)
	{ ::CopyRect(this, &srcRect); }
CRect::CRect(LPCRECT lpSrcRect)
	{ ::CopyRect(this, lpSrcRect); }
CRect::CRect(POINT point, SIZE size)
	{ right = (left = point.x) + size.cx; bottom = (top = point.y) + size.cy; }
CRect::CRect(POINT topLeft, POINT bottomRight)
	{ left = topLeft.x; top = topLeft.y;
		right = bottomRight.x; bottom = bottomRight.y; }
int CRect::Width() const
	{ return right - left; }
int CRect::Height() const
	{ return bottom - top; }
CSize CRect::Size() const
	{ return CSize(right - left, bottom - top); }
CPoint& CRect::TopLeft()
	{ return *((CPoint*)this); }
CPoint& CRect::BottomRight()
	{ return *((CPoint*)this+1); }
const CPoint& CRect::TopLeft() const
	{ return *((CPoint*)this); }
const CPoint& CRect::BottomRight() const
	{ return *((CPoint*)this+1); }
CPoint CRect::CenterPoint() const
	{ return CPoint((left+right)/2, (top+bottom)/2); }
void CRect::SwapLeftRight()
	{ SwapLeftRight(LPRECT(this)); }
void CRect::SwapLeftRight(LPRECT lpRect)
	{ LONG temp = lpRect->left; lpRect->left = lpRect->right; lpRect->right = temp; }
CRect::operator LPRECT()
	{ return this; }
CRect::operator LPCRECT() const
	{ return this; }
BOOL CRect::IsRectEmpty() const
	{ return ::IsRectEmpty(this); }
BOOL CRect::IsRectNull() const
	{ return (left == 0 && right == 0 && top == 0 && bottom == 0); }
BOOL CRect::PtInRect(POINT point) const
	{ return ::PtInRect(this, point); }
void CRect::SetRect(int x1, int y1, int x2, int y2)
	{ ::SetRect(this, x1, y1, x2, y2); }
void CRect::SetRect(POINT topLeft, POINT bottomRight)
	{ ::SetRect(this, topLeft.x, topLeft.y, bottomRight.x, bottomRight.y); }
void CRect::SetRectEmpty()
	{ ::SetRectEmpty(this); }
void CRect::CopyRect(LPCRECT lpSrcRect)
	{ ::CopyRect(this, lpSrcRect); }
BOOL CRect::EqualRect(LPCRECT lpRect) const
	{ return ::EqualRect(this, lpRect); }
void CRect::InflateRect(int x, int y)
	{ ::InflateRect(this, x, y); }
void CRect::InflateRect(SIZE size)
	{ ::InflateRect(this, size.cx, size.cy); }
void CRect::DeflateRect(int x, int y)
	{ ::InflateRect(this, -x, -y); }
void CRect::DeflateRect(SIZE size)
	{ ::InflateRect(this, -size.cx, -size.cy); }
void CRect::OffsetRect(int x, int y)
	{ ::OffsetRect(this, x, y); }
void CRect::OffsetRect(POINT point)
	{ ::OffsetRect(this, point.x, point.y); }
void CRect::OffsetRect(SIZE size)
	{ ::OffsetRect(this, size.cx, size.cy); }
BOOL CRect::IntersectRect(LPCRECT lpRect1, LPCRECT lpRect2)
	{ return ::IntersectRect(this, lpRect1, lpRect2);}
BOOL CRect::UnionRect(LPCRECT lpRect1, LPCRECT lpRect2)
	{ return ::UnionRect(this, lpRect1, lpRect2); }
void CRect::operator=(const RECT& srcRect)
	{ ::CopyRect(this, &srcRect); }
BOOL CRect::operator==(const RECT& rect) const
	{ return ::EqualRect(this, &rect); }
BOOL CRect::operator!=(const RECT& rect) const
	{ return !::EqualRect(this, &rect); }
void CRect::operator+=(POINT point)
	{ ::OffsetRect(this, point.x, point.y); }
void CRect::operator+=(SIZE size)
	{ ::OffsetRect(this, size.cx, size.cy); }
void CRect::operator+=(LPCRECT lpRect)
	{ InflateRect(lpRect); }
void CRect::operator-=(POINT point)
	{ ::OffsetRect(this, -point.x, -point.y); }
void CRect::operator-=(SIZE size)
	{ ::OffsetRect(this, -size.cx, -size.cy); }
void CRect::operator-=(LPCRECT lpRect)
	{ DeflateRect(lpRect); }
void CRect::operator&=(const RECT& rect)
	{ ::IntersectRect(this, this, &rect); }
void CRect::operator|=(const RECT& rect)
	{ ::UnionRect(this, this, &rect); }
CRect CRect::operator+(POINT pt) const
	{ CRect rect(*this); ::OffsetRect(&rect, pt.x, pt.y); return rect; }
CRect CRect::operator-(POINT pt) const
	{ CRect rect(*this); ::OffsetRect(&rect, -pt.x, -pt.y); return rect; }
CRect CRect::operator+(SIZE size) const
	{ CRect rect(*this); ::OffsetRect(&rect, size.cx, size.cy); return rect; }
CRect CRect::operator-(SIZE size) const
	{ CRect rect(*this); ::OffsetRect(&rect, -size.cx, -size.cy); return rect; }
CRect CRect::operator+(LPCRECT lpRect) const
	{ CRect rect(this); rect.InflateRect(lpRect); return rect; }
CRect CRect::operator-(LPCRECT lpRect) const
	{ CRect rect(this); rect.DeflateRect(lpRect); return rect; }
CRect CRect::operator&(const RECT& rect2) const
	{ CRect rect; ::IntersectRect(&rect, this, &rect2);
		return rect; }
CRect CRect::operator|(const RECT& rect2) const
	{ CRect rect; ::UnionRect(&rect, this, &rect2);
		return rect; }
BOOL CRect::SubtractRect(LPCRECT lpRectSrc1, LPCRECT lpRectSrc2)
	{ return ::SubtractRect(this, lpRectSrc1, lpRectSrc2); }

void CRect::InflateRect(LPCRECT lpRect)
{
	left -= lpRect->left;
	top -= lpRect->top;
	right += lpRect->right;
	bottom += lpRect->bottom;
}

void CRect::DeflateRect(LPCRECT lpRect)
{
	left += lpRect->left;
	top += lpRect->top;
	right -= lpRect->right;
	bottom -= lpRect->bottom;
}


int AfxMessageBox(LPCTSTR lpszText, UINT nType, UINT nIDHelp)
{
	return MessageBox(NULL, lpszText, "MSU", nType);
}

#endif
