#ifndef __MSU_STRUCTS_H
#define __MSU_STRUCTS_H


namespace MSU
{

// defend from any aligment
#pragma pack( push, before ) 
#pragma pack(1)

inline unsigned char int2char(int x)
{
	return (x<=0) ? (unsigned char)0 :
		((x>=255) ? (unsigned char)255 : (unsigned char)x);
}

struct TRGBColor
{
	TRGBColor(): blue(0), green(0), red(0) {}
	TRGBColor(unsigned char _red, unsigned char _green, unsigned char _blue): blue(_blue), green(_green), red(_red) {}
	bool operator==(const TRGBColor &color) { return red==color.red && green==color.green && blue==color.blue; }
	bool operator!=(const TRGBColor &color) { return ! (*this==color); }

// Operations (NOTE: use CVect3 for complex operations)
	void operator+=(const TRGBColor& c) { red=int2char((int)red+c.red); green=int2char((int)green+c.green); blue=int2char((int)blue+c.blue); }
	void operator-=(const TRGBColor& c) { red=int2char((int)red-c.red); green=int2char((int)green-c.green); blue=int2char((int)blue-c.blue); }
	void operator^=(const TRGBColor& c) { red=int2char((int)red^c.red); green=int2char((int)green^c.green); blue=int2char((int)blue^c.blue); }
	void operator|=(const TRGBColor& c) { red=int2char((int)red|c.red); green=int2char((int)green|c.green); blue=int2char((int)blue|c.blue); }
	void operator&=(const TRGBColor& c) { red=int2char((int)red&c.red); green=int2char((int)green&c.green); blue=int2char((int)blue&c.blue); }
	void Assign(const TRGBColor& c) { *this=c; }

	TRGBColor operator+(const TRGBColor& c) const { return TRGBColor(int2char((int)red+c.red), int2char((int)green+c.green), int2char((int)blue+c.blue)); }
	TRGBColor operator-(const TRGBColor& c) const { return TRGBColor(int2char((int)red-c.red), int2char((int)green-c.green), int2char((int)blue-c.blue)); }
	TRGBColor operator^(const TRGBColor& c) const { return TRGBColor(int2char((int)red^c.red), int2char((int)green^c.green), int2char((int)blue^c.blue)); }
	TRGBColor operator|(const TRGBColor& c) const { return TRGBColor(int2char((int)red|c.red), int2char((int)green|c.green), int2char((int)blue|c.blue)); }
	TRGBColor operator&(const TRGBColor& c) const { return TRGBColor(int2char((int)red&c.red), int2char((int)green&c.green), int2char((int)blue&c.blue)); }

	unsigned char blue;
	unsigned char green;
	unsigned char red;
};
// restore aligment settings
#pragma pack( pop, before )


} //  namespace MSU



#endif